# all

abstract fun all(selectionAction: Action<in ComponentSelection>): ComponentSelectionRules

Adds a simple component selection rule that will apply to all resolved components. Each rule will receive a ComponentSelection object as an argument.

#### Return

this

#### Parameters

selectionAction

the Action that implements a rule to be applied

abstract fun all(@DelegatesTo(value = ComponentSelection::class) closure: Closure<out Any>): ComponentSelectionRules

Adds a component selection rule that will apply to all resolved components. Each rule will receive a ComponentSelection object as an argument.

#### Return

this

#### Parameters

closure

the Closure that implements a rule to be applied

abstract fun all(ruleSource: Any): ComponentSelectionRules

### Deprecated

use all instead.

Adds a rule-source backed component selection rule that will apply to all resolved components. The ruleSource provides the rule as exactly one rule method annotated with org.gradle.model.Mutate. This rule method:

- must return void.
- must have org.gradle.api.artifacts.ComponentSelection as its parameter.

#### Return

this

#### Parameters

ruleSource

an instance providing a rule implementation